{Cette unit est utilis pour attendre la recherche des ordinateurs du reseau.
En effet, la recherche peut etre assez longue et donc je bloque la souris pendant le temps de la recherche.}

unit UnitPatience;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TFormPatience = class(TForm)
    StaticText1: TStaticText;
    BitBtnRechercheFini: TBitBtn;
    StaticText2: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RechercheEffective;
    procedure TrierRessource;
    procedure AfficherPosteReseau;
    function ExistOrdiReseau(Ordi:string) :boolean;
    procedure BitBtnRechercheFiniClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    
  private
    { Dclarations prives }
    procedure SystemeCommande(var Msg : TMessage);
    message WM_SysCommand; // interception des messages SysCommand
    procedure TraiteContainer(PBufferI: PNetResource);
  public
    { Dclarations publiques }
  end;

var
  FormPatience: TFormPatience;
  TableauRessource : array of string;
  CompteurTableauRessource : integer;

implementation

uses UnitChatRL;

{$R *.dfm}

procedure TFormPatience.FormCreate(Sender: TObject);
begin
   CompteurTableauRessource :=0;
   StaticText1.Cursor := crHourGlass;
   BitBtnRechercheFini.Cursor := crHourGlass;
   cursor := crHourGlass;
end;


procedure TFormPatience.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  n: Integer;  // Sert dans l'activation de CtrlAltSupp et AltTab
begin
     SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0, @n, 0); // Permet  la fermeture de ractiver CtrlAltSupp et AltTab
     ClipCursor(nil); // Annule la limitation du dplacement de la souris.
end;


procedure TFormPatience.SystemeCommande(var Msg : TMessage);
begin
    //inherited; // instruction pour que les messages soient traits normalement
    if Msg.wParam = sc_Close then ; // Rponse au Alt-F4
end;


procedure TFormPatience.TraiteContainer(PBufferI: PNetResource);
type
  tBufferResultat = array[0..0] of TNetResource;
  tpBufferResultat = ^tBufferResultat;
var
  HandleEnum:THandle;
  NbRessources:DWord;
  TailleBuffer:DWord;
  i:integer;
  pBufferResultat: tpBufferResultat;
  NumErreur:integer;

 
begin
   if WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, PBufferI, HandleEnum) <> NO_ERROR then
     ShowMessage('Erreur' + IntToStr(GetLastError))
   else
   begin
     // allouer un buffer avec une taille arbitraire (pas 0 sinon pBufferResultat serait : nil
     TailleBuffer :=16384;// 16Ko
     pBufferResultat := AllocMem(TailleBuffer);
     NumErreur:=NO_ERROR;

     // boucler tant qu'il y a des ressources  numrer et qu'il n'y a pas d'erreur
     while NumErreur<>ERROR_NO_MORE_ITEMS do //Tant qu'il y a des ressources  trouver
     begin
       NbRessources := $ffffffff; // on ne limite pas le nombre de ressources demandes
       NumErreur:=WNetEnumResource(HandleEnum, NbRessources, pBufferResultat, TailleBuffer);
      //NbRessource contient maintenant le nomnbre de ressource de ce container
      //(container = noeud si on considre l'arborescence du rseau)
      //(Ressource = branche si on considre l'arborescence du rseau)

       case  NumErreur of
         ERROR_MORE_DATA:
           // le buffer tait trop petit pour rcuprer une resource,
           // rallouer de la mmoire en tenant compte de la nouvelle valeur de TailleBuffer
           // renvoye par WNetEnumResource
           ReallocMem(pBufferResultat, TailleBuffer);
           // cela dit, avec TailleBuffer=16Ko, peu de chance d'avoir ce problme

         NO_ERROR:
           begin
             // pas d'erreur, on peut donc exploiter les ressources renvoyes par le Buffer
             // le nombre de ressources renvoyes est limit par la taille du Buffer (TailleBuffer)
             // s'il y a d'autres ressources, elles seront renvoyes au prochain tour du While

             for i:=0 to NbRessources-1 do
             begin

                 SetLength(TableauRessource, 1+CompteurTableauRessource);
                 TableauRessource[CompteurTableauRessource] :=  string(pBufferResultat^[i].lpRemoteName);
                 inc(CompteurTableauRessource);

                 // faire un F1 sur le mot NETRESOURCE pour connaitre tous les renseignements contenus dans
                 // pBufferResultat^[i]
               if pBufferResultat^[i].dwUsage and RESOURCEUSAGE_CONTAINER=RESOURCEUSAGE_CONTAINER then
                   traiteContainer(@pBufferResultat^[i]);// une petite rcursivit pour aller plus profond dans l'arbre....
             end;
           end
         else
           if NumErreur<> ERROR_NO_MORE_ITEMS then
           begin
             // une vraie erreur est survenue
             ShowMessage('Erreur' + IntToStr(GetLastError));
             break; // pour sortir du While
           end;
       end; // fin du case
     end;   // fin du while
     WNetCloseEnum(HandleEnum);// libration des ressources
     FreeMem(pBufferResultat);// libration de la mmoire
   end;
end;


procedure TFormPatience.TrierRessource;
var
    i,j : integer;
begin
   for i:=0 to length(TableauRessource)-1 do
   begin
       if TableauRessource[i]<> '' then
       begin
           if copy(TableauRessource[i],1,2)= '\\' then
           begin
              TableauRessource[i] := copy(TableauRessource[i],3,length(TableauRessource[i])-1);
              for j:=0 to length(TableauRessource[i])-1 do
              begin
                 if copy (TableauRessource[i],j,1) = '\' then
                 begin
                    TableauRessource[i] := '';
                 end;
              end;
           end;
       end;
   end;
end;


procedure TFormPatience.AfficherPosteReseau;
var
  i : integer;
begin
   application.ProcessMessages;
   for i:=0 to length(TableauRessource)-1 do
   begin
      if TableauRessource[i] <> '' then
      begin
         if ExistOrdiReseau(TableauRessource[i]) then
         begin
             ChatRL.ListBoxListeRL.Items.Add(TableauRessource[i]);
             ChatRL.ComboBoxListeOrdinateur.Items.Add(TableauRessource[i]);
         end;
      end;

   end;
end;


function TFormPatience.ExistOrdiReseau(Ordi:string):boolean;
// attention si par exemple \\ordi5 existe
//il faudra passer comme valeur Ordi : '\\ordi5' et non 'ordi5'
// ou '\\ordi5\'
var
  PRessource: PNetResource;
  HandleEnum:THandle;
begin
  result:=true;
  PRessource := AllocMem(16384);// 16Ko
  PRessource.lpRemoteName:=LPTSTR('\\'+Ordi);
  if WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_ANY, 0, PRessource, HandleEnum) <> NO_ERROR then
     result:=false;
  WNetCloseEnum(HandleEnum);
  FreeMem(pRessource);
end;


procedure TFormPatience.RechercheEffective;
begin
  Application.ProcessMessages;
  TraiteContainer(nil);//nil permet de dmarrer  la racine
  application.ProcessMessages;
  TrierRessource;
  AfficherPosteReseau;

  StaticText1.Cursor := crDefault;
  BitBtnRechercheFini.Cursor := crDefault;
  cursor := crDefault;
  BitBtnRechercheFini.Visible := TRUE;
end;

procedure TFormPatience.BitBtnRechercheFiniClick(Sender: TObject);
begin
     ChatRL.BitBtnActualiserReseau.Enabled := TRUE;
     FormPatience.Close;
end;

procedure TFormPatience.FormShow(Sender: TObject);
var
   n: Integer;  // Sert dans la dactivation de CtrlAltSupp et AltTab
   Rect: TRect;   // Zone de limitation pour la souris
begin
   application.ProcessMessages;
   SystemParametersInfo(SPI_SCREENSAVERRUNNING, Integer(TRUE), @n, 0);  // Dsactiver CtrlAltSupp et AltTab

   { Convertie les coordonnes de la fiche avec celles de l'cran }
   Rect.TopLeft:= ClientToScreen(ClientRect.TopLeft);
   Rect.BottomRight:= ClientToScreen(ClientRect.BottomRight);
   ClipCursor(@Rect); // Limite le dplacement de la souris  la zone Client de la fiche.
end;

end.
